Unit ACDopredna;

//////////////////////////////////////////
(*
 Reprezentace dopredne funkce algoritmu
 Aho-Corasickove.
*)
//////////////////////////////////////////

Interface

Const
      G_UNDEFINED = -1;

Function  G(AQ:Integer; AZn:Char):Integer;
Procedure DefinujG(AQ:Integer; AZn:Char; AQR:Integer);
Procedure InitG;
Procedure DestroyG;

Implementation

Uses ACHashTable;

Var HT : PHashTable;

Function G(AQ:Integer; AZn:Char):Integer;
(*
 Vrati hodnotu dopredne funkce pro stav AQ
 a pismeno AZn. V pripade, ze fukce neni
 pro dany stav a pismeno definovana, vraci
 -1.
 AQ - stav
 AZn - pismeno
*)
begin
Result:=HTSearch(HT,AQ,AZn);
end;

Procedure DefinujG(AQ:Integer; AZn:Char; AQR:Integer);
(*
 Definuje hodnotu dopredne funkce G ve stavu
 AQ s pismenem AZn do stavu AQR.
 AQ  - vychozi stav
 AZn - pismeno
 AQR - cilovy stav
*)
begin
HTAdd(HT,AQ,AZn,AQR);
end;

Procedure InitG;
begin
HT:=HTInit;
end;

Procedure DestroyG;
begin
HTDestroy(HT);
end;

End.
