Unit NaiveAlg;

//////////////////////////////////////////
(*
 Implementace velmi trivialniho, naivniho
 a tupeho algoritmu na vyhledavani vzorku
 v textu. Princip je velmi jednoduchy.

 Definujme M delku vstupniho textu T a L
 jako pocet vzorku V. Postup je takovy, ze
 pro kazde J z {1,2,...,L} je J-ty vzorek delky
 N pustupne prikladan na I-te pozice vtextu
 T (pro I z {1,2,...,M-N}). Takovymto porovnavanim
 je nakonec zjistena pozice vyskytu vsech
 vzorku. Slozitost vyhledavani je
 O ( L * (M - N )).
*)
//////////////////////////////////////////

Interface

Uses
   TextSearcAlg;

Type
   // Trida reprezentuje specificky vyhledavaci
   // algoritmus - naivni algoritmus.
   // Odvozeneho z obecneho algoritmu pro
   // vyhledavani v textu.
   TNaiveAlg = Class (TTextSearchAlgorithm)
               Public
                // Metda DoSearch udela
                // vesktere vyhledavani a
                // vygeneruje vystup.
                Procedure DoSearch; Override;
               end;

Implementation

Procedure TNaiveAlg.DoSearch;
Var L : Integer;
    N : Integer;
    M : Integer;
    J : Integer;
    I : Integer;
begin
L:=FPatterns.Count;
M:=Length(FText);
// Pres vsechny vzorky
For J:=0 To L-1 Do
    begin
    N:=Length(FPatterns[J]);
    // Pro vsechny "relevantni" pozice v
    // prohledavanem textu.
    For I:=1 To M-N Do
        begin
        // Takhle lze treba porovnavat retezce.
        // Stejne jako v Pascalu
        If Copy(FText,I,N) = FPatterns[J] Then
           OutputAdd(I,J);
        end;
    end;
end;

End.
